package java2.autoload.demo;

import java.io.File;
import java.lang.annotation.Annotation;
import java.util.ArrayList;
import java.util.List;

public class ReflectionDemo2 {
	
	public static void main(String[] args) {
		
		Package curr_package = ReflectionDemo2.class.getPackage();
		String package_name = curr_package == null ? "" : curr_package.getName();
		
		File path = new File(package_name.replaceAll("\\.", "/"));
		System.out.println("Loading from " + path.getAbsoluteFile() + " ...");
		
		List<Class<?>> list1 = new ArrayList<>();		
		for (String file: path.list()) {
			String full_classname = package_name + "." + file.substring(0, file.length() - 6);
			if (file.endsWith(".class")) {
	        	try {
	        		Class<?> c = Class.forName(full_classname);
	        		list1.add(c);
	        	}
	        	catch (ClassNotFoundException e) {
					System.err.println("Cannot find " + full_classname);
				}
			}
		}
		for (Class<?> c: list1) System.out.println(c.getName());
		
		System.out.println("\nThe following classes are tagged:");
		
		List<Class<?>> tagged_classes = new ArrayList<>();
		for (Class<?> c: list1) {
			Annotation[] anns = c.getDeclaredAnnotations();
			for (Annotation ann: anns) {
				if (ann.toString().contains("@java2.autoload.demo.Tag")) tagged_classes.add(c);
			}
		}
		
		for (Class<?> c: tagged_classes) System.out.println(c.getName());
			
	}
}
